// CalcChipNumView.cpp : CCalcChipNumView NX̎
//

#include "stdafx.h"
#include "CalcChipNum.h"

#include "CalcChipNumDoc.h"
#include "CalcChipNumView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCalcChipNumView

IMPLEMENT_DYNCREATE(CCalcChipNumView, CFormView)

BEGIN_MESSAGE_MAP(CCalcChipNumView, CFormView)
	ON_BN_CLICKED(IDC_BUTTON_CALC		, &CCalcChipNumView::OnBnClickedButtonCalc)
	ON_BN_CLICKED(IDC_BUTTON_ADD_TARGET	, &CCalcChipNumView::OnBnClickedButtonAddTarget)
	ON_BN_CLICKED(IDC_BUTTON_PICTURE	, &CCalcChipNumView::OnBnClickedButtonPicture)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_COPY_PARA	, &CCalcChipNumView::OnBnClickedButtonCopyPara)
	ON_BN_CLICKED(IDC_BUTTON_PASTE_PARA	, &CCalcChipNumView::OnBnClickedButtonPastePara)
	ON_LBN_SELCHANGE(IDC_LIST_KIND		, &CCalcChipNumView::OnLbnSelchangeListKind)
	ON_BN_CLICKED(IDC_BUTTON_UP			, &CCalcChipNumView::OnBnClickedButtonUp)
	ON_BN_CLICKED(IDC_BUTTON_RIGHT		, &CCalcChipNumView::OnBnClickedButtonRight)
	ON_BN_CLICKED(IDC_BUTTON_DOWN		, &CCalcChipNumView::OnBnClickedButtonDown)
	ON_BN_CLICKED(IDC_BUTTON_LEFT		, &CCalcChipNumView::OnBnClickedButtonLeft)
	ON_BN_CLICKED(IDC_CHECK_SIZEDOWN	, &CCalcChipNumView::OnBnClickedCheckSizedown)
END_MESSAGE_MAP()

// CCalcChipNumView RXgNV/fXgNV

CCalcChipNumView::CCalcChipNumView()
	: CFormView(CCalcChipNumView::IDD)
{
	m_nSel			= 0;
	m_strDataPath	= "";
}

CCalcChipNumView::~CCalcChipNumView()
{
}

void CCalcChipNumView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_PARA1			, m_ctlPara1);
	DDX_Control(pDX, IDC_EDIT_PARA2			, m_ctlPara2);
	DDX_Control(pDX, IDC_EDIT_PARA3			, m_ctlPara3);
	DDX_Control(pDX, IDC_EDIT_PARA4			, m_ctlPara4);
	DDX_Control(pDX, IDC_EDIT_PARA5			, m_ctlPara5);
	DDX_Control(pDX, IDC_EDIT_PARA6			, m_ctlPara6);
	DDX_Control(pDX, IDC_EDIT_PARA7			, m_ctlResult);
	DDX_Control(pDX, IDC_EDIT_PARA8			, m_ctlName);
	DDX_Control(pDX, IDC_BUTTON_ADD_TARGET	, m_ctlAddTarget);
	DDX_Control(pDX, IDC_STATIC_PICTURE		, m_ctlPicture);
	DDX_Control(pDX, IDC_EDIT_PARA9			, m_ctlPicFile);
	DDX_Control(pDX, IDC_EDIT1				, m_ctlPath);
	DDX_Control(pDX, IDC_LIST_KIND			, m_ctlSelect);
	DDX_Control(pDX, IDC_BUTTON_UP			, m_ctlUp);
	DDX_Control(pDX, IDC_BUTTON_DOWN		, m_ctlDown);
	DDX_Control(pDX, IDC_BUTTON_RIGHT		, m_ctlRight);
	DDX_Control(pDX, IDC_BUTTON_LEFT		, m_ctlLeft);
	DDX_Control(pDX, IDC_CHECK_SIZEDOWN		, m_ctlFullPicture);
	DDX_Control(pDX, IDC_EDIT_PARA10		, m_ctlText);
}

BOOL CCalcChipNumView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CFormView::PreCreateWindow(cs);
}

void CCalcChipNumView::OnInitialUpdate()
{
	CString	path;

	pDoc	= GetDocument();
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	path = GetDocument()->GetPathName();
	m_strDataPath = GetPath( path);
	if( m_strDataPath != ""){
		m_ctlPath.SetWindowText( m_strDataPath);
	}
	RefreshCombo();
	RefreshPara();
}


// CCalcChipNumView ff

#ifdef _DEBUG
void CCalcChipNumView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCalcChipNumView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CCalcChipNumDoc* CCalcChipNumView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCalcChipNumDoc)));
	return (CCalcChipNumDoc*)m_pDocument;
}
#endif //_DEBUG

#include	<math.h>
// CCalcChipNumView bZ[W nh

void CCalcChipNumView::OnBnClickedButtonCalc()
{
	double	len;
	double	d;
	double	l;
	int		c;
	double	last;

	CString	str;

	int		i;

	m_nSel = m_ctlSelect.GetCurSel();
	m_ctlName.GetWindowText( str);	pDoc->m_strName[ m_nSel] = str;
	RefreshCombo();
	m_ctlPara1.GetWindowText( str);	pDoc->m_dPara[ m_nSel][0] = atof( str);
	m_ctlPara2.GetWindowText( str);	pDoc->m_dPara[ m_nSel][1] = atof( str);
	m_ctlPara3.GetWindowText( str);	pDoc->m_dPara[ m_nSel][2] = atof( str);
	m_ctlPara4.GetWindowText( str);	pDoc->m_dPara[ m_nSel][3] = atof( str);
	m_ctlPara5.GetWindowText( str);	pDoc->m_dPara[ m_nSel][4] = atof( str);
	m_ctlPara6.GetWindowText( str);	pDoc->m_dPara[ m_nSel][5] = atof( str);
	pDoc->SetModifiedFlag();

	len = 0;
	last = pDoc->m_dPara[ m_nSel][ 0] + pDoc->m_dPara[ m_nSel][ 4]*2;
	d = pDoc->m_dPara[ m_nSel][ 0];
	for( i = 0 ; i < 100; i++){
		d += (pDoc->m_dPara[ m_nSel][ 2] * 2);
		l = d * 3.14159;
		len += l;
		if( d >= last) break;
	}
	len -= ( l * (1.0 - pDoc->m_dPara[ m_nSel][ 5]));
	c = (int)( len / pDoc->m_dPara[ m_nSel][ 3]);
	str.Format( "%d (%5.0fmm,%dstep)", c, len, i+1);
	m_ctlResult.SetWindowText( str);
}

void CCalcChipNumView::RefreshCombo(void)
{
	CString	str;
	int		i;

	m_ctlSelect.ResetContent();
	for( i = 0 ; i < pDoc->m_nTarget; i++){
		str.Format( "%2d: %s", i+1, pDoc->m_strName[ i]);
		m_ctlSelect.AddString( str);
	}
	m_ctlSelect.SetCurSel( m_nSel);
	m_ctlAddTarget.EnableWindow( pDoc->m_nTarget < MAX_TARGET);
}

void CCalcChipNumView::RefreshPara(void)
{
	CString	str;
	m_ctlName.SetWindowText( pDoc->m_strName[ m_nSel]);
	m_ctlPicFile.SetWindowText( pDoc->m_strPic[ m_nSel]);
	KickPicure();
	str.Format( "%5.2f", pDoc->m_dPara[ m_nSel][ 0]);	m_ctlPara1.SetWindowText( str);
	str.Format( "%5.2f", pDoc->m_dPara[ m_nSel][ 1]);	m_ctlPara2.SetWindowText( str);
	str.Format( "%5.2f", pDoc->m_dPara[ m_nSel][ 2]);	m_ctlPara3.SetWindowText( str);
	str.Format( "%5.2f", pDoc->m_dPara[ m_nSel][ 3]);	m_ctlPara4.SetWindowText( str);
	str.Format( "%5.2f", pDoc->m_dPara[ m_nSel][ 4]);	m_ctlPara5.SetWindowText( str);
	str.Format( "%5.2f", pDoc->m_dPara[ m_nSel][ 5]);	m_ctlPara6.SetWindowText( str);
}

void CCalcChipNumView::OnBnClickedButtonAddTarget()
{
	if( pDoc->m_nTarget < MAX_TARGET){
		pDoc->m_nTarget++;
		m_nSel = pDoc->m_nTarget-1;
		RefreshCombo();
		RefreshPara();
	}
}

void CCalcChipNumView::OnBnClickedButtonPicture()
{
	UpdateData( TRUE);
	CFileDialog dialog(	TRUE,
						_T("jpg/gif"),
						_T("*.jpg"),
						OFN_FILEMUSTEXIST|OFN_SHOWHELP,
												// OPENFILENAME		OFN_CREATEPROMPT
						"jpeg file(*.jpg)|*.jpg|gif file(*.gif)|*.gif||",
												// 
						NULL					// 
						);
	if( dialog.DoModal() == IDOK){
		pDoc->m_strPic[ m_nSel] = GetRelativePath( dialog.GetPathName());
		KickPicure();
	}
}

CString CCalcChipNumView::GetRelativePath(CString data)
{
	CString	temp;
	int		start;

	if( m_strDataPath == "") return data;

	while( 1){
		start = data.Find( m_strDataPath, 0);
		if( start >= 0){
			temp = data.Left( start);
			data = temp + data.Right( data.GetLength() - temp.GetLength() - m_strDataPath.GetLength());
		} else {
			break;
		}
	}
	return data;
}

void CCalcChipNumView::DisplayPicture( CString file)
{
	CDC		*pDC = m_ctlPicture.GetDC();
	CRect	rect;
	CImage	img;
	CImage	img2;
	double	scale;
	int		x, y;
	int		w, h;
	CString	str;

	if( file == ""){
		m_ctlPicture.GetClientRect( &rect);
		pDC->Rectangle( rect);
		return;
	}
	if( m_strDataPath != ""){
		file = m_strDataPath + "\\" + file;
	}
	if( img.Load( file) == 0){
		m_ctlPicture.GetClientRect( &rect);
		if(( img.GetWidth() < rect.Width() ) && ( img.GetHeight() < rect.Height())){				// ̂܂ܕ\
			pDC->Rectangle( rect);
			x = ( rect.Width() - img.GetWidth())/2;
			y = ( rect.Height() - img.GetHeight())/2;
			img.Draw( pDC->m_hDC, rect.left+x, rect.top+y, img.GetWidth(), img.GetHeight());
		} else {
			if( m_ctlFullPicture.GetCheck()){
				pDC->Rectangle( rect);
				pDC->TextOut( rect.Width()/2-50, rect.Height()/2, "Wait a little");
				if(( img.GetWidth() / rect.Width() ) >= ( img.GetHeight() / rect.Height())){		// k\
					scale = img.GetWidth() / rect.Width()+0.2;										// kڂ߂
				} else {
					scale = img.GetHeight() / rect.Height()+0.2;
				}
				img2.Create( img.GetWidth()/scale, img.GetHeight()/scale, img.GetBPP());			// 摜sNZRs[鏀
				for( x = 0 ; x < img2.GetWidth() ; x++){
					for( y = 0 ; y < img2.GetHeight() ; y++){
						img2.SetPixel( x, y, img.GetPixel( x*scale, y*scale));
					}
				}
				x = ( rect.Width() - img2.GetWidth())/2;
				y = ( rect.Height() - img2.GetHeight())/2;
				img2.Draw( pDC->m_hDC, x, y);
			} else {																				// \
				pDC->Rectangle( rect);
				img.BitBlt(pDC->m_hDC, 0, 0, rect.Width(),rect.Height(), ( img.GetWidth()-rect.Width())/2 + pDoc->m_dX[ m_nSel]*img.GetWidth(), ( img.GetHeight() - rect.Height())/2+pDoc->m_dY[ m_nSel]*img.GetHeight());
			}
		}
		str.Format( "(%d,%d)", img.GetWidth(), img.GetHeight());
		pDC->TextOut( rect.left+10, rect.bottom - 20, str);
	}
	ReleaseDC( pDC);
	m_ctlUp.RedrawWindow( );
	m_ctlDown.RedrawWindow( );
	m_ctlRight.RedrawWindow( );
	m_ctlLeft.RedrawWindow( );
}

void CCalcChipNumView::KickPicure(void)
{
	SetTimer( 1, 100, NULL);
}

void CCalcChipNumView::OnTimer(UINT_PTR nIDEvent)
{
	if( nIDEvent == 1){
		KillTimer( nIDEvent);
		DisplayPicture( pDoc->m_strPic[ m_nSel]);
	}

	CFormView::OnTimer(nIDEvent);
}

CString CCalcChipNumView::GetPath( CString filepath)
{
	CString	str;
	int		i;

	if( filepath.GetLength() > 0){
		for( i = filepath.GetLength()-1; i > 0; i--){
			if( filepath.GetAt( i) == '\\'){
				break;
			}
		}
		return filepath.Left( i);
	} else {
		return "";
	}
}

void CCalcChipNumView::OnBnClickedButtonCopyPara()
{
	int	i;

	for( i = 0 ; i < 6; i++){
		m_dPara[ i]	= pDoc->m_dPara[ m_nSel][ i];
	}
	m_strName	= pDoc->m_strName[ m_nSel];
	m_strPic	= pDoc->m_strPic[ m_nSel];
}

void CCalcChipNumView::OnBnClickedButtonPastePara()
{
	int	i;

	for( i = 0 ; i < 6; i++){
		pDoc->m_dPara[ m_nSel][ i]	= m_dPara[ i];
	}
	pDoc->m_strName[ m_nSel]	= m_strName;
	pDoc->m_strPic[ m_nSel]		= m_strPic;
	RefreshCombo();
	RefreshPara();
	pDoc->SetModifiedFlag();
}

void CCalcChipNumView::OnLbnSelchangeListKind()
{
	m_nSel = m_ctlSelect.GetCurSel();
	RefreshCombo();
	RefreshPara();
}

void CCalcChipNumView::OnBnClickedButtonUp()
{
	if( pDoc->m_dY[ m_nSel] < 0.4){
		pDoc->m_dY[ m_nSel] += 0.1;
		KickPicure();
	}
}

void CCalcChipNumView::OnBnClickedButtonDown()
{
	if( pDoc->m_dY[ m_nSel] > -0.4){
		pDoc->m_dY[ m_nSel] -= 0.1;
		KickPicure();
	}
}

void CCalcChipNumView::OnBnClickedButtonRight()
{
	if( pDoc->m_dX[ m_nSel] > -0.4){
		pDoc->m_dX[ m_nSel] -= 0.1;
		KickPicure();
	}
}


void CCalcChipNumView::OnBnClickedButtonLeft()
{
	if( pDoc->m_dX[ m_nSel] < 0.4){
		pDoc->m_dX[ m_nSel] += 0.1;
		KickPicure();
	}
}

void CCalcChipNumView::OnBnClickedCheckSizedown()
{
	KickPicure();
}
